function [obj,L,break_K] = fem_0_mainKM (in_data,type_analysis)

% -------------------------------------------------------------------------


[dofN] = fem_0_elemType (in_data);
dof_   = size(in_data.ND,1)*dofN;

in_data.SUB = 1;

if  isfield(in_data,'SUB')
    switch in_data.SUB
        case 2
            disp([' static condensation:  2']);
            HF = floor((dof_/2)/dofN)*dofN;
            break_K = [ 1 HF HF+1  dof_ ];
            [obj.Ksys.Kgl_11, obj.M_11] = fem_1_assemKM (in_data, ...
                                type_analysis,break_K(1:2),break_K(1:2));
            [obj.Ksys.Kgl_12, obj.M_12] = fem_1_assemKM (in_data, ...
                                type_analysis,break_K(1:2),break_K(3:4));
            obj.Ksys.Kgl_21 = obj.Ksys.Kgl_12';
            obj.M_21 = obj.M_12';
            [obj.Ksys.Kgl_22, obj.M_22] = fem_1_assemKM (in_data, ...
                                type_analysis,break_K(3:4),break_K(3:4));
        case 1
            break_K = [1 dof_];
            disp(' static condensation: NONE');
            [obj.Ksys.Kgl, obj.M] = fem_1_assemKM (in_data, ...
                                type_analysis,[1 dof_],[1 dof_]);
            obj.M = fem_1_assemLumpedM(in_data,obj.M,dofN);
        otherwise
            disp(' !!! Check static condensation parameter');
            return;
    end
else
    break_K = [1 dof_];
    disp(' static condensation: NONE');
    [obj.Ksys.Kgl, obj.M] = fem_1_assemKM(in_data, ...
                               type_analysis,break_K,break_K);
end

sp_=sprintf('\n');
disp([sp_  '  ...   K, M - completed.']);

if  isfield(in_data,'T')
    L=0;
else
    [obj,L] = fem_1_assemCon(dofN, dof_, obj, in_data);
end

disp([sp_  '  ...   Vector of constraints -- OK.']);



