function fem_1_dynAnim2Dbeam(resp,in_data)

% -------------------------------------------------------------------------


dofN = 3; 
dof_ = size(in_data.ND)*dofN;
warning off;
XXX = max(max(abs( resp.dynamic.dva(:,1:dofN:dof_))));
YYY = max(max(abs( resp.dynamic.dva(:,2:dofN:dof_))));

ha = figure('Name','Dynamic response animation','NumberTitle','off', ...
     'Menubar','none');
axis off; text(0.2,0.5,'To stop animation close the window','FontSize',14);
pause(1.5);
clf(ha)


x = [0:size(resp.dynamic.dva,1)-1]./(size(resp.dynamic.dva,1)-1);
hAx = axes('Parent',ha, 'XLim',[0 1], 'YLim',[0 1], ...
      'XTick',[], 'YTick',[], 'Box','on', 'Layer','top', ...
      'Units','normalized', 'Position',[0 0.98 0.998 0.02]);
hPatch = patch([0 0 x(1) x(1)], [0 1 1 0], 'r', 'Parent',hAx, ...
      'FaceColor','r', 'EdgeColor','none');
hAx2 = axes('Parent',ha, 'XLim',[0 1], 'YLim',[0 1], ...
      'XTick',[], 'YTick',[], 'Box','on', 'Layer','top', ...
      'Units','normalized', 'Position',[0 0.02 1 0.9]);
hPatch2 = patch([0 0 x(1) x(1)], [0 1 1 0], 'w', 'Parent',hAx2, ...
      'FaceColor','none', 'EdgeColor','none');


for k=1:size(resp.dynamic.dva,1)
    if ishandle(ha) 
        set(hPatch, 'XData',[0 0 x(k) x(k)]);
        axes(hAx2);                          
        fem_2_dynAnim2DbeamFrame(in_data,resp.dynamic.dva(k,1:dof_), ...
            k,dof_, XXX,YYY, ha);
        hold off;
        drawnow;
    else
        break;
    end;
end;
% -------------------------------------------------------------------------

