function in_data = beam_3d_test (in_data)


in_data.ND = [   1   0   0   0.0;
                 2   0   0   0.1;
                 3   0   0   0.2;
                 4   0   0   0.3;
                 5   0   0   0.4;
                 6   0   0   0.5;
                 7   0   0   0.6;
                 8   0   0   0.7;
                 9   0   0   0.8;
                10   0   0   0.9;
                11   0   0   1.0];

E   = 2.0e11;   % Pa
nu  = 0.3;      % Poisson's ratio
G   = E/(2*(1+nu));
b   = 0.1;
ho  = 0.2 ;
rho = 7890;     % [kg/m3]

in_data.mater.rho=0;
in_data.mater.b=0;
in_data.mater.ho=0;
in_data.mater.E=0;
in_data.mater.G=0;

in_data.EL = [1  3   1  2  E  G  b   ho rho nu;
              2  3   2  3  E  G  b   ho rho nu;
              3  3   3  4  E  G  b   ho rho nu;
              4  3   4  5  E  G  b   ho rho nu;
              5  3   5  6  E  G  b   ho rho nu;
              6  3   6  7  E  G  b   ho rho nu;
              7  3   7  8  E  G  b   ho rho nu;
              8  3   8  9  E  G  b   ho rho nu;
              9  3   9 10  E  G  b   ho rho nu;
             10  3  10 11  E  G  b   ho rho nu];

in_data.CON   = [ 1  0  0  0  0  0  0 ];

in_data.LOAD_ = [ 11 0 1 0 0 0 0   ];

in_data.MASS  = [    ];


%----------------------------------
in_data.dynam.TIMEH     = [ 'bedr.txt' ];
in_data.dynam.delta_tm  = [0.0079];
in_data.dynam.TIMEHDIR  = [1 0 0 0 0 0];
in_data.dynam.TIMEHM    = [1:length(in_data.ND)*3]; 
in_data.dynam.TIMEHPL   = [9*6-4];    
in_data.dynam.DAMP_C    = [0.06 0.06];
in_data.dynam.DAMP_F    = [3];         
in_data.dynam.ab        = [0.04 0.001];
in_data.dynam.MODA      = [1];
