function  [resp,t] = fem_1_mainDynamic(obj,in_data,L,LK)

% -------------------------------------------------------------------------


if in_data.EL(1,2)==9 || in_data.EL(1,2)==4 || in_data.EL(1,2)==5 || ...
        in_data.EL(1,2)==3 || in_data.EL(1,2)==6 || in_data.EL(1,2)==0 ...
        || in_data.EL(1,2)==1 || in_data.EL(1,2)==2 || in_data.EL(1,2)==51 ...
        || in_data.EL(1,2)==10 || in_data.EL(1,2)==31
    [resp.dynamic.dva, t] = fem_2_dyn( in_data, obj, L,LK);
end; 

zdd    = load(in_data.dynam.TIMEH);

if ~isempty(in_data.dynam.TIMEHPL~=0)
    RESP_ = resp.dynamic.dva(:,2*LK+in_data.dynam.TIMEHPL(1));
    accL = length(RESP_);
    [FT_T,omega] = fem_2_dynFft(zdd(1:accL), real(RESP_) , ...
        abs(t(2)-t(1)),9123);
    [SAinp,SAout,T] = fem_2_respSpec(zdd(1:accL), real(RESP_) , ...
        abs(t(2)-t(1)),9124);
    A = which ('tmp_dir.txt'); cd (A(1:end-12)); 
    save FEM_DYN_RESP.txt RESP_ -ascii;
end

sp_=sprintf('\n');
disp([sp_ '--- Dynamic response --> "FEM_DYN_RESP.txt"']);

